$ontext
Copyright (C)   2006 Shiro Takeda
Time-stamp: 	<2008-03-23 03:06:17 Shiro Takeda>
$Id: trade_lib_data.gms,v 1.2 2006/07/29 12:42:58 st Exp $
version:
Author: 	Shiro Takeda <zbc08106@park.zero.ad.jp>
e-mail:		<zbc08106@park.zero.ad.jp>
First-written:	<2005/04/02>

$offtext

*	Dataset specification
$if not setglobal ds $setglobal ds gtap6_trade_lib

*	Model choice:
$if not setglobal mod_pc $setglobal mod_pc 1
$if not setglobal mod_cd $setglobal mod_cd 1
$if not setglobal mod_lgmc $setglobal mod_lgmc 1
$if not setglobal mod_ch $setglobal mod_ch 1
$if not setglobal mod_cf $setglobal mod_cf 1
$if not setglobal mod_qcv $setglobal mod_qcv 1
$if not setglobal mod_bd $setglobal mod_bd 1
$if not setglobal mod_ic $setglobal mod_ic 1
$if not setglobal mod_ib $setglobal mod_ib 1
$if not setglobal mod_cm $setglobal mod_cm 0

*	Liberalization participants:
$if not setglobal lib_p $setglobal lib_p scn_g

*	Model size
$if not setglobal fl_small $setglobal fl_small 0
$if not setglobal fl_large $setglobal fl_large 0
$if not setglobal fl_normal $setglobal fl_normal 1

*	Non-zero means the model where CDR is calibrated.
$if not setglobal fl_cdr $setglobal fl_cdr 0

*	Calibraion only
$if not setglobal calib_only $setglobal calib_only 0

*	Benchmark replication only
$if not setglobal br_only $setglobal br_only 0

*	Cleanup calculation only
$if not setglobal cc_only $setglobal cc_only 0

*	Scale check
$if not setglobal sc_chk $setglobal sc_chk 0

*	Flag for AFF.  If non-zero, AFF is assumed to be an imperfectly
*	competitive sector.
$if not setglobal fl_aff $setglobal fl_aff 0

*	Scale factor for EOS (default is unity):
$if not setglobal sc_eos $setglobal sc_eos 1

*	Value of CDR.
$if not setglobal cdr $setglobal cdr 0.15

*	The benchmark number of firms (valid only in model QCV and CDR
*	calibration model).
$if not setglobal n_0 $setglobal n_0 50

*	Tariff on service trade.  If not zero, tariffs on service trade are
*	introduced.
$if not setglobal fl_ser $setglobal fl_ser 1

*	Solver for solving the model (non-zero means MCP, otherwise NLP)
$if not setglobal fl_mcp $setglobal fl_mcp 1

*	Solver for calibration (non-zero means MCP, otherwise NLP)
$if not setglobal fl_mcp_c $setglobal fl_mcp_c 1

*	Alternative model for model IB.
$if not setglobal fl_ib_alt $setglobal fl_ib_alt 0

*	----------------------------------------------------------------------
*	Import data.
$include ..\gtap6data
alias (r,rr);
alias (r,t), (r, tt), (s, ss);
set	r_s(r,s);
r_s(r,s) = no;
r_s(r,r) = yes;
display r_s;

$include .\trade_lib_set_def.gms
display ser_sec;

set
    k(i)	Imperfectly competititve sectors
    l(i)	Perfectly competititve sectors
;
*	----------------------------------------------------------------------
*	Benchmark data:
display "com: Benchmark data:";
* display i, r, f, vafm, vfm, vxmd, vtwr, vst, vdgm, vigm, vdpm, vipm, vxm, vim,
* 	vdm, vdfm, vi, vifm, vom, vgm, vpm, vg, vp, vt, evoa, vb, vm, va,
* 	market, vdep, vkb;

* display vdga, viga, vdgm, vigm, vdpa, vipa, vdpm, vipm, evoa, evfa, vfm, vdfa;
* display vifa, vdfm, vifm, vims, viws, vxmd, vxwd, vst, vtwr, fbep, isep;
* display osep, adrv, tfrv, purv, vrrv, mfrv, xtrv;
* display vdm, vom, voa, vom;
* display vtw, vpm, vgm, vim, evom, vb;

*	----------------------------------------------------------------------
*	Tax rates:
display "com: Tax rates:";
* display rto, rtf, rtpd, rtpi, rtgd, rtgi, rtfd, rtfi, rtxs, rtms;
* display rtf0, rtpd0, rtpi0, rtgd0, rtgi0, rtfd0, rtfi0, rtxs0, rtms0;
display rtms, rtxs;

*	----------------------------------------------------------------------
*	Elasticity parameters:
display "com: Elasticity parameters:";
* display esubd, esubva, esubm, etrae;
display esubd, esubva;

*	----------------------------------------------------------------------
*	Aggregate trade margin:
display "com: Aggregate trade margin:";

parameter
    vtwr_(i,r,s)	Trade margin (aggregate)
;
vtwr_(i,r,s) = sum(j, vtwr(j,i,r,s));
* display vtwr_;

*	----------------------------------------------------------------------
*	Remove small trade data:
display "com: Remove small trade data:";
display "Before adjustment",vb;

parameter
    chk_vxmd
    chk_vtwr
    chk_rtms
    chk_rtxs
;
chk_vxmd(i,r,s)$(abs(vxmd(i,r,s)) < 1e-8) = vxmd(i,r,s);
chk_vtwr(i,r,s)$(vtwr_(i,r,s) and (not vxmd(i,r,s))) = vtwr_(i,r,s);
chk_rtxs(i,r,s)$(abs(rtxs(i,r,s)) < 1e-3) = rtxs(i,r,s);
display chk_vxmd, chk_vtwr, chk_rtxs;

vxmd(i,r,s)$(abs(vxmd(i,r,s)) < 1e-8) = 0;
display vxmd;

vtwr_(i,r,s)$(vtwr_(i,r,s) and (not vxmd(i,r,s))) = 0;
display vtwr_;

vb(r) = vpm(r) + vgm(r) + sum(cgd,vom(cgd,r)) 
	- sum(f, evom(f,r))
	- sum(j,  vom(j,r)*rto(j,r))
	- sum(j,  sum(i, vdfm(i,j,r)*rtfd(i,j,r) + vifm(i,j,r)*rtfi(i,j,r)))
	- sum(j,  sum(f, vfm(f,j,r)*rtf(f,j,r)))
	- sum(i, vdpm(i,r)*rtpd(i,r) + vipm(i,r)*rtpi(i,r))
	- sum(i, vdgm(i,r)*rtgd(i,r) + vigm(i,r)*rtgi(i,r))
	- sum((i,s), rtms(i,s,r) *  (vxmd(i,s,r) * (1-rtxs(i,s,r)) + vtwr_(i,s,r)))
	+ sum((i,s), rtxs(i,r,s) * vxmd(i,r,s));
vb("chksum") = sum(r, vb(r));
display "After adjustment", vb;

*	Total import:
vim(i,r) = sum(s,(vxmd(i,s,r)*(1-rtxs(i,s,r))+vtwr_(i,s,r))*(1+rtms(i,s,r)));

*	----------------------------------------------------------------------
*	Aggregate demand:
display "com: Aggregate demand:";

parameter
    v_pm(i,r)		Private households purchases at market prices
    v_gm(i,r)		Government purchases at market prices
    v_fm(i,j,r)		Intermediates purchases at market prices

    v_pa(i,r)		Private households purchases at agent prices
    v_ga(i,r)		Government purchases at agent prices
    v_fa(i,j,r)		Intermediates purchases at agent prices

    rtp(i,r)		Tax rates on private demand
    rtg(i,r)		Tax rates on government demand
    rti(i,j,r)		Intermediate tax rates
;
v_pm(i,r) = vdpm(i,r) + vipm(i,r);
v_gm(i,r) = vdgm(i,r) + vigm(i,r);
v_fm(i,j,r) = vdfm(i,j,r) + vifm(i,j,r);
* display v_pm, v_gm, v_fm;

v_pa(i,r) = vdpa(i,r) + vipa(i,r);
v_ga(i,r) = vdga(i,r) + viga(i,r);
v_fa(i,j,r) = vdfa(i,j,r) + vifa(i,j,r);
* display v_pa, v_ga, v_fa;

rtp(i,r)$v_pm(i,r) = (v_pa(i,r)/v_pm(i,r) - 1);
rtg(i,r)$v_gm(i,r) = (v_ga(i,r)/v_gm(i,r) - 1);
rti(i,j,r)$v_fm(i,j,r) = (v_fa(i,j,r)/v_fm(i,j,r) - 1);
* display rtp, rtg, rti;

*	----------------------------------------------------------------------
*	Aggregate private and government demand:
display "com: Aggregate private and government demand:";

parameter
    vdcm(i,r)		Final demand (domestic)
    vicm(i,r)		Final demand (imported)
    v_cm(i,r)		Final demand at market prices
    vcm(r)		Aggregate final demand

    vdca(i,r)		Final demand (domestic) at agent prices
    vica(i,r)		Final demand (imported) at agent prices
    v_ca(i,r)		Final demand at agent prices

    rtc(i,r)		Tax rates on final demand
;
vdcm(i,r) = vdpm(i,r) + vdgm(i,r);
vicm(i,r) = vipm(i,r) + vigm(i,r);
v_cm(i,r) = vdcm(i,r) + vicm(i,r);
* display vdcm, vicm, v_cm;

vdca(i,r) = vdpa(i,r) + vdga(i,r);
vica(i,r) = vipa(i,r) + viga(i,r);
v_ca(i,r) = vdca(i,r) + vica(i,r);
* display vdca, vica, v_ca;

rtc(i,r)$v_cm(i,r) = (v_ca(i,r)/v_cm(i,r) - 1);
* display rtc;

vcm(r) = sum(i, (1+rtc(i,r)) * v_cm(i,r));

vdpm(i,r) = 0;
vdgm(i,r) = 0;
vipm(i,r) = 0;
vigm(i,r) = 0;
vdpa(i,r) = 0;
vdga(i,r) = 0;
vipa(i,r) = 0;
viga(i,r) = 0;
rtpd(i,r) = 0;
rtpi(i,r) = 0;
rtgd(i,r) = 0;
rtgi(i,r) = 0;

rtpd0(i,r) = 0;
rtpi0(i,r) = 0;
rtgd0(i,r) = 0;
rtgi0(i,r) = 0;

vpm(r) = 0;
vgm(r) = 0;

*	----------------------------------------------------------------------
*	Reference prices:
display "com: Reference prices:";
parameter
	pc0(i,r)	Reference price for final demand
        po0(i,r)        Reference output price (domestic or export),
        pai0(j,i,r)     Reference price for intermediate inputs,
        pf0(f,i,r)      Reference price for factor inputs

        pmx0(i,s,r)     Reference price of imports,
        pmt0(i,s,r)     Reference price of transport services,
	pmm0(i,r,s)	Price of import (net of tariff)
	pm0(i,r,s)	Price of import (gross of tariff)
	pxx0(i,r,s)	World price of export
;
pc0(i,r) = 1 + rtc(i,r);
po0(i,r) = 1 - rto(i,r);
pai0(j,i,r) = 1 + rti(j,i,r);
pf0(f,j,s) = 1 + rtf(f,j,s);
* display pc0, po0, pai0, pf0;

pvxmd(i,s,r) = (1 + rtms0(i,s,r)) * (1 - rtxs0(i,s,r));
pvtwr(i,s,r) = 1 + rtms0(i,s,r);
* display pvxmd, pvtwr;

pmm0(i,r,s) = 1 - rtxs(i,r,s);
pmt0(i,s,r) = (1 + rtms(i,s,r));
pmx0(i,s,r) = pmt0(i,s,r) * pmm0(i,s,r);
* display pmm0, pmt0, pmx0;

*	----------------------------------------------------------------------
*	Calibrate tariff on services:
parameter
    tax_rev_fd	Tax revenue from final demand
    chk_tariff_rev
    chk_tariff
    inc_tr	Increase in tariff revenue;

parameter
    m0(i,r,s)		Value of import (exc. tariff)
    m0_(i,r,s)		Value of import
;
m0(i,r,s) = vxmd(i,r,s);
m0_(i,r,s) = (1-rtxs(i,r,s))*vxmd(i,r,s) + vtwr_(i,r,s);
* display m0, m0_;

*	Include data of tariff on service trade:
$include .\tariff_on_services.gms

if(%fl_ser%,
    display "com: Calibrate tariff on services:";

*	Original tax revenue from final consumption:
    tax_rev_fd(i,r) = rtc(i,r)*v_cm(i,r);

*	Introduce tariff on service trade:
    display t_on_ser;
    rtms(ser_sec,s,r) = t_on_ser(r,ser_sec)/100;
    display rtms;

    pvxmd(i,s,r) = (1 + rtms(i,s,r)) * (1 - rtxs0(i,s,r));
    pvtwr(i,s,r) = 1 + rtms(i,s,r);
    pmm0(i,r,s) = 1 - rtxs0(i,r,s);
    pmt0(i,s,r) = (1 + rtms(i,s,r));
    pmx0(i,s,r) = pmt0(i,s,r) * pmm0(i,s,r);

*	Increase in value of tariff revenue:
    inc_tr(ser_sec,s)
	= sum(r, rtms(ser_sec,r,s) * m0_(ser_sec,r,s)
	- rtms0(ser_sec,r,s) * m0_(ser_sec,r,s));
    display inc_tr;

*	New value of import:
    display "Before", vim;
    vim(i,r) = sum(s,(vxmd(i,s,r)*(1-rtxs(i,s,r))+vtwr_(i,s,r))*(1+rtms(i,s,r)));
    display "After", vim;

*	New value of final consumption of imported goods:
    display "Before", vicm;
    vicm(ser_sec,r) = vicm(ser_sec,r) + inc_tr(ser_sec,r);
    display "After", vicm;

*	Consumption = private expenditure + government expenditure:
    v_cm(i,r) = vicm(i,r)+vdcm(i,r);

    rtms0(ser_sec,r,s) = rtms(ser_sec,r,s);
    rtc(i,r)$v_cm(i,r) = tax_rev_fd(i,r) / v_cm(i,r);
    pc0(i,r) = 1 + rtc(i,r);
    vcm(r) = sum(i, pc0(i,r) * v_cm(i,r));
    display rtms0, rtc, pc0, vcm;
);

vb(r) = vcm(r) + sum(cgd,vom(cgd,r))
	- sum(f, evom(f,r))
	- sum(j, vom(j,r)*rto(j,r))
	- sum(j, sum(i, rti(i,j,r) * v_fm(i,j,r)))
	- sum(j, sum(f, vfm(f,j,r)*rtf(f,j,r)))
	- sum(i, rtc(i,r) * v_cm(i,r))
	- sum((i,s), rtms(i,s,r) *  (vxmd(i,s,r) * (1-rtxs(i,s,r)) + vtwr_(i,s,r)))
	+ sum((i,s), rtxs(i,r,s) * vxmd(i,r,s));
vb("chksum") = sum(r, vb(r));
display "After adjustment", vb;

*	----------------------------------------------------------------------
*	Armington demand:
display "com: Armington demand:";
parameter
    a0(i,r)		Armington supply
    am0(i,r)		Aggregate import supply
    ad0(i,r)		Aggregate domestic supply
;
a0(i,r) = vdcm(i,r) + vicm(i,r) + sum(j, vdfm(i,j,r) + vifm(i,j,r));
ad0(i,r) = vdcm(i,r) + sum(j, vdfm(i,j,r));
am0(i,r) = vicm(i,r) + sum(j, vifm(i,j,r));
display a0, ad0, am0;

*	----------------------------------------------------------------------
*	Investment:
display "com: Investment:";
parameter
    inv		Investment;
inv(r) = vom("cgds",r);
* display inv;

*	----------------------------------------------------------------------
*	Trade data:
display "com: Trade data:";
parameter
    vimm(i,r,s)		Import + transport services
;
vimm(i,r,s)$vxmd(i,r,s)
    = vxmd(i,r,s)*(1-rtxs(i,r,s)) + vtwr_(i,r,s);
* display vimm;

*	----------------------------------------------------------------------
*	Other data and parameters:
display "com: Other data and parameters:";

parameter
    vad(i,r)		Sectoral value-added
    vt			Value of transport services
    tau(i,r,s)		Unit transport cost coefficient
    tau0(i,r,s)		Unit transport cost coefficient
;
vad(i,r) = sum(f, vfm(f,i,r) * pf0(f,i,r));
vt = sum((i,r), vst(i,r));
tau(i,r,s)$vxmd(i,r,s) = vtwr_(i,r,s) / vxmd(i,r,s);
tau0(i,r,s) = tau(i,r,s);
* display vad, vt, tau;
display tau, tau0;

*	----------------------------------------------------------------------
*	CDR
display "com: CDR";
parameter cdr	Cost disadvantage ratio;
cdr(i,r) = 0;
$include %cdr_file%
display cdr;
k(i)$sum(rnum, cdr(i,rnum)) = yes;
l(i)$(not k(i)) = yes;
display k, l;

*	----------------------------------------------------------------------
*	Scale parameters:
display "com: Scale parameters:";
parameter
    scale_f(f,r)	Parameter for scale check
    scale_bop(r)	Parameter for scale check
    scale_i(r)		Parameter for scale check
;
scale_f(f,r) = 1;
scale_bop(r) = 1;
scale_i(r) = 1;

*	----------------------------------------------------------------------
*	Share parameters.
display "com: Share parameters.";
parameter
    sh_i(j,i,r)		Share of each intermediate inputs
    sh_pf(i,r)		Share of primary factor composite
    sh_f(f,i,r)		Share of each primary factor
    sh_am(i,r)	 	Share of import goods in Armington aggregation
    sh_ad(i,r)	 	Share of domestic goods in Armington aggregation
    sh_m(i,r,s) 	Share of import goods
    sh_c(i,r)		Share of each good in consumption
    sh_t(i,r)		Share of inputs in transport
    gamma(i,s,r)	goods share of unit import cost

    sh_sd		Domestic supply share
    sh_sx		Export supply share
;

pxx0(i,r,s) = (1 - rtxs(i,r,s));
* display pxx0;

sh_i(j,i,r)$vom(i,r) = pai0(j,i,r) * v_fm(j,i,r)
    / (po0(i,r) * vom(i,r));
sh_pf(i,r)$vad(i,r) = vad(i,r) / (po0(i,r) * vom(i,r));
* display sh_i, sh_pf;

sh_f(f,i,r)$vad(i,r) = pf0(f,i,r) * vfm(f,i,r) / vad(i,r);
* display sh_f;

sh_am(i,r)$a0(i,r) = am0(i,r) / a0(i,r);
sh_ad(i,r)$a0(i,r) = ad0(i,r) / a0(i,r);
* display sh_am, sh_ad;

sh_c(i,r)$vcm(r) = pc0(i,r) * v_cm(i,r) / vcm(r);
* display sh_c;

sh_t(i,r)$sum((j,s), vst(j,s)) = vst(i,r) / vt;
* display sh_t;

sh_m(i,s,r)$vxmd(i,s,r) =
    (vxmd(i,s,r) * pmx0(i,s,r) + vtwr_(i,s,r) * pmt0(i,s,r) ) / vim(i,r);
* display sh_m;

gamma(i,s,r)$vxmd(i,s,r)
    = pmm0(i,s,r)*vxmd(i,s,r) / (pmm0(i,s,r)*vxmd(i,s,r) + vtwr_(i,s,r));
* display gamma;

*	Share of domestic supply:
sh_sd(i,r)$vdm(i,r)
    = vdm(i,r) / (vdm(i,r) + sum(s, vxmd(i,r,s)));
*	Share of export supply:
sh_sx(i,r,s)$vxmd(i,r,s)
    = vxmd(i,r,s) / (vdm(i,r) + sum(rr, vxmd(i,r,rr)));
* display sh_sd, sh_sx;

parameter
    sh_trns(i,r)	Share of output to transport sector in total output;
sh_trns(i,r)$k(i) = vst(i,r) / vom(i,r);
display sh_trns;

* --------------------
* Local Variables:
* mode: gams
* fill-column: 78
* End:
